#!/usr/bin/sh

VERSION="1.3.2"
REVISION="1"
ARCHITECTURE=`uname -r | sed 's,[^-]*-[^-]*-,,'`
BINARIES="../../binaries/Release"
INCLUDE="../../include/"

echo "Uncompressing files"
tar -xvzf ./Debian.tar.gz > /dev/null
cd Debian
echo "Retrieving built binaries"
cp $BINARIES/bin/ProceduralGenerator										./ProceduralGenerator/usr/bin
cp $BINARIES/lib/libGenerator.a 											./ProceduralGenerator-dev/usr/lib
cp $INCLUDE/Generator/* 													./ProceduralGenerator-dev/usr/include/Generator
cp $BINARIES/share/ProceduralGenerator/libBuggedLifeGame.so 				./BuggedLifeGame/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libColoredLifeGame.so				./ColoredLifeGame/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libDiffusionLimitedAggregation.so	./DiffusionLimitedAggregation/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libImageEffects.so					./ImageEffects/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libIteratedFunctionSystem.so			./IteratedFunctionSystem/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libLifeGame.so						./LifeGame/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libPerlinNoise.so					./PerlinNoise/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libShaderEffects.so					./ShaderEffects/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libShaderWebcam.so					./ShaderWebcam/usr/share/ProceduralGenerator/
cp $BINARIES/share/ProceduralGenerator/libVoronoi2D.so						./Voronoi2D/usr/share/ProceduralGenerator/
echo "Building debian packages"
for i in *
do
	if [ -d $i ]; then
		conv=`echo "$i" | tr '[A-Z]' '[a-z]'`
		dpkg-deb --build $i "$conv"_"$VERSION"-"$REVISION"_"$ARCHITECTURE".deb > /dev/null
	fi
done
echo "Building archive"
mkdir Packages
cp INSTALL-ORDER Packages/INSTALL-ORDER
mv *.deb Packages
cd Packages
tar -czf Packages.tar.gz ./*
mv Packages.tar.gz ../../
cd ../../
rm -r -f ./Debian
